# Class AbstractSingleArchiveResource

java.lang.Object
org.apache.catalina.webresources.AbstractResource
org.apache.catalina.webresources.AbstractArchiveResource
org.apache.catalina.webresources.AbstractSingleArchiveResource

All Implemented Interfaces:
  `WebResource`

Direct Known Subclasses:
  `JarResource, WarResource`

public abstract class AbstractSingleArchiveResource extends AbstractArchiveResource
Abstract `WebResource` implementation for resources within a single archive (e.g., a JAR file).

## Nested Class Summary

### Nested classes/interfaces inherited from class AbstractArchiveResource

`AbstractArchiveResource.JarInputStreamWrapper`

## Field Summary

### Fields inherited from class AbstractResource

`sm`

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`AbstractSingleArchiveResource(AbstractArchiveResourceSet archiveResourceSet, String webAppPath, String baseUrl, JarEntry jarEntry, String codeBaseUrl)`
Constructs a new AbstractSingleArchiveResource.

## Method Summary

Modifier and Type
Method
Description
`protected AbstractArchiveResource.JarInputStreamWrapper`
`getJarInputStreamWrapper()`
Gets the JAR input stream wrapper for this resource.

### Methods inherited from class AbstractArchiveResource

`canRead, delete, doGetInputStream, exists, getArchiveResourceSet, getBase, getBaseUrl, getCanonicalPath, getCertificates, getCodeBase, getContent, getContentLength, getCreation, getLastModified, getManifest, getName, getResource, getURL, isDirectory, isFile, isVirtual`

### Methods inherited from class AbstractResource

`getETag, getInputStream, getLastModifiedHttp, getLog, getMimeType, getStrongETag, getWebappPath, getWebResourceRoot, setMimeType`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### AbstractSingleArchiveResource

protected AbstractSingleArchiveResource(AbstractArchiveResourceSet archiveResourceSet, String webAppPath, String baseUrl, JarEntry jarEntry, String codeBaseUrl)
Constructs a new AbstractSingleArchiveResource.

Parameters:
  `archiveResourceSet` - The archive resource set
  `webAppPath` - The web app path
  `baseUrl` - The base URL
  `jarEntry` - The JAR entry
  `codeBaseUrl` - The code base URL

## Method Details

### getJarInputStreamWrapper

protected AbstractArchiveResource.JarInputStreamWrapper getJarInputStreamWrapper()
Gets the JAR input stream wrapper for this resource.

Specified by:
  `getJarInputStreamWrapper` in class `AbstractArchiveResource`
Returns:
  the JAR input stream wrapper, or `null` if an error occurs